<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h1>#{messages['gazelle.ordermanager.LaboratoryLabelInformationProvider']}</h1>
        <h:form id="gform">
            <s:div id="globalDiv">
                <gri:panel pid="globalPanel">
                    <f:facet name="header">
                        #{messages['gazelle.ordermanager.LabelDeliberyRequest']}
                    </f:facet>
                    <!-- SUT Selection -->
                    <s:div id="sutSelect">
                        <ui:include src="/configuration/initiatorFrame.xhtml">
                            <ui:param name="diagramImg" value="#{labelDeliveryRequestSender.sequenceDiagramPath}"/>
                            <ui:param name="currentConfig" value="#{userPreferencesManagerBean.selectedSUT}"/>
                            <ui:param name="simuFacility" value="#{labelDeliveryRequestSender.sendingFacility}"/>
                            <ui:param name="simuApplication" value="#{labelDeliveryRequestSender.sendingApplication}"/>
                            <ui:param name="sectionsToReRender"
                                      value="sendMessageButtonDiv"/>
                            <ui:param name="simulatorConfigurationName" value="#{messages['gazelle.ordermanager.LabLabelInformationProvider']}"/>
                            <ui:param name="availableSuts" value="#{labelDeliveryRequestSender.getAvailableSuts()}"/>
                        </ui:include>
                    </s:div>
                    <br/>
                    <s:div rendered="#{labelDeliveryRequestSender.hl7Messages == null}">
                        <!-- New order Div -->
                        <gri:panel pid="encounterSelectionPanel"
                                   rendered="#{labelDeliveryRequestSender
                               .selectedEncounter == null and labelDeliveryRequestSender
                               .selectPatient}">
                            <f:facet name="header">#{messages['gazelle.ordermanager.PatientAndEncounterSelection']}</f:facet>
                            <s:div styleClass="gzl-never-wrap" id="newEncounterButtons">
                                <a4j:commandLink
                                        actionListener="#{labelDeliveryRequestSender.displayAvailableCountries()}"
                                        render="encounterSelectionPanel" styleClass="gzl-btn-blue"
                                        rendered="#{labelDeliveryRequestSender.selectionType != 'DDS'}">
                                    <h:outputText
                                            value="#{messages['gazelle.ordermanager.NewPatient']}"/>
                                </a4j:commandLink>
                                <a4j:commandLink
                                        actionListener="#{labelDeliveryRequestSender.setSelectionType('PATIENT')}"
                                        render="encounterSelectionPanel" styleClass="gzl-btn-blue"
                                        rendered="#{labelDeliveryRequestSender.selectionType != 'PATIENT'}">
                                    <h:outputText
                                            value="#{messages['gazelle.ordermanager.ExistingPatient']}"/>
                                </a4j:commandLink>
                                <a4j:commandLink
                                        actionListener="#{labelDeliveryRequestSender.setSelectionType('ENCOUNTER')}"
                                        render="encounterSelectionPanel" styleClass="gzl-btn-blue"
                                        rendered="#{labelDeliveryRequestSender.selectionType != 'ENCOUNTER'}">
                                    <h:outputText
                                            value="#{messages['gazelle.ordermanager.ExistingEncounters']}"/>
                                </a4j:commandLink>
                            </s:div>
                            <br/>
                            <!-- Generate a new patient -->
                            <gri:panel rendered="#{labelDeliveryRequestSender.selectionType == 'DDS'}">
                                <f:facet name="header">
                                    #{messages['gazelle.ordermanager.PatientAndEncounterGeneration']}
                                </f:facet>
                                <h:outputText
                                        value="#{messages['gazelle.ordermanager.ChooseACountryForTheGeneratedPatient']}"
                                        styleClass="help-block"/>
                                <ui:include src="/patient/patientGenerator.xhtml">
                                    <ui:param name="patientGeneratorBean" value="#{labelDeliveryRequestSender
                                }"/>
                                    <ui:param name="displayAllCriteria" value="trueF"/>
                                    <ui:param name="ddsEndpoint"
                                              value="#{applicationConfiguration.getValueOfVariable('dds_ws_endpoint')}"/>
                                </ui:include>
                                <f:facet name="footer">
                                    <a4j:commandButton id="generateButton"
                                                       value="#{messages['gazelle.ordermanager.Generate']}"
                                                       actionListener="#{labelDeliveryRequestSender
                                                   .createNewPatientAndEncounter()}"
                                                       styleClass="gzl-btn-blue" render="globalDiv"/>
                                    <a4j:commandButton value="#{messages['users.Cancel']}"
                                                       actionListener="#{labelDeliveryRequestSender
                                                   .cancelPatientCreation()}"
                                                       styleClass="gzl-btn-orange" render="globalDiv"/>
                                </f:facet>
                            </gri:panel>
                            <br/>
                            <!-- Select an existing encounter -->
                            <s:div id="encounterSelection"
                                   rendered="#{labelDeliveryRequestSender
                               .selectionType == 'ENCOUNTER'}">
                                <f:subview id="encFilterView">
                                    <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">

                                        <ui:define name="filter_buttons">
                                            <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                             render="encounterSelection">
                                                <span class="gzl-icon-refresh"/>
                                            </a4j:commandLink>
                                            <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                             actionListener="#{labelDeliveryRequestSender
                                                         .encounterFilter.reset()}"
                                                             render="encounterSelection">
                                                <span class="gzl-icon-times-circle"/>
                                            </a4j:commandLink>
                                        </ui:define>
                                        <ui:include src="/common/filtersOnEncounter.xhtml">
                                            <ui:param name="formId" value="encounterSelection"/>
                                            <ui:param name="filterClass" value="#{labelDeliveryRequestSender
                                        .encounterFilter}"/>
                                        </ui:include>
                                    </ui:decorate>
                                </f:subview>
                                <br/>
                                <br/>
                                #{dataTableStateHolder.setDescendingOn('creationDate')}
                                <rich:dataTable id="encountersTable"
                                                value="#{labelDeliveryRequestSender
                                            .encounterFilter.getEncounterFiltered()}" var="enc"
                                                rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                                render="ds">
                                    <ui:include src="/common/encounterColumns.xhtml">
                                        <ui:param name="encounter" value="#{enc}"/>
                                        <ui:param name="displayPatientInfo"
                                                  value="true"/>
                                        <ui:param name="extendedTable"
                                                  value="false"/>
                                    </ui:include>
                                    <g:column>
                                        <ui:define name="header">#{messages['users.Action']}</ui:define>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.Select']}"
                                                         actionListener="#{labelDeliveryRequestSender
                                                     .selectEncounter(enc)}"
                                                         render="globalDiv">
                                            <span class="gzl-icon-medkit"/>
                                        </a4j:commandLink>
                                    </g:column>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="ds"/>
                                            <ui:param name="dataTableId" value="encountersTable"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </s:div>
                            <!-- Select an existing patient -->
                            <s:div id="patientSelection"
                                   rendered="#{labelDeliveryRequestSender
                               .selectionType == 'PATIENT'}">
                                <f:subview id="patFilterView">
                                    <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                                        <ui:define name="filter_buttons">
                                            <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                             render="patientSelection">
                                                <span class="gzl-icon-refresh"/>
                                            </a4j:commandLink>
                                            <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                             actionListener="#{labelDeliveryRequestSender
                                                         .patientFilter.reset()}"
                                                             render="patientSelection">
                                                <span class="gzl-icon-times-circle"/>
                                            </a4j:commandLink>
                                        </ui:define>
                                        <ui:include src="/common/filtersOnPatient.xhtml">
                                            <ui:param name="formId" value="patientSelection"/>
                                            <ui:param name="filterClass" value="#{labelDeliveryRequestSender
                                        .patientFilter}"/>
                                        </ui:include>
                                    </ui:decorate>
                                </f:subview>
                                <br/>
                                <br/>
                                #{dataTableStateHolder.setDescendingOn('creationDate')}
                                <rich:dataTable value="#{labelDeliveryRequestSender
                            .patientFilter.getPatientsFiltered()}" var="pat"
                                                rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="patientsTable"
                                                render="ds">
                                    <ui:include src="/common/patientColumns.xhtml">
                                        <ui:param name="patient" value="#{pat}"/>
                                    </ui:include>
                                    <g:column>
                                        <ui:define name="header">#{messages['users.Action']}</ui:define>
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.Select']}"
                                                         actionListener="#{labelDeliveryRequestSender
                                                     .createANewEncounterForPatient(pat)}"
                                                         render="globalDiv">
                                            <span class="gzl-icon-medkit"/>
                                        </a4j:commandLink>
                                    </g:column>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="ds"/>
                                            <ui:param name="dataTableId" value="patientsTable"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </s:div>
                        </gri:panel>
                        <!-- Display information about selected encounter and patient -->
                        <s:div id="newObjectPart" rendered="#{labelDeliveryRequestSender.selectedEncounter != null}">
                            <gri:panel>
                                <f:facet
                                        name="header">#{messages['gazelle.ordermanager.SelectedPatientAndEncounter']}</f:facet>
                                <ui:include src="/common/displayPatientEncounter.xhtml">
                                    <ui:param name="patient" value="#{labelDeliveryRequestSender.selectedPatient}"/>
                                    <ui:param name="encounter" value="#{labelDeliveryRequestSender.selectedEncounter}"/>
                                </ui:include>
                                <f:facet name="footer">
                                    <a4j:commandButton
                                            value="#{messages['gazelle.ordermanager.SelectAnotherEncounter']}"
                                            actionListener="#{labelDeliveryRequestSender.onChangeActionEvent()}"
                                            immediate="true" styleClass="gzl-btn-orange"
                                            render="globalDiv"/>
                                </f:facet>
                            </gri:panel>
                            <!-- Display panel to fill the order/specimen/container -->
                            <s:div id="spmdetails">
                                <gri:panel pid="spmpanel">
                                    <f:facet name="header"><h:outputText value="#{messages['gazelle.ordermanager.SpecimenDetails']}"/>
                                        <span style="width:10px"/>
                                        <a4j:commandLink
                                                title="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                                actionListener="#{labelDeliveryRequestSender.fillSpecimenRandomly()}"
                                                immediate="true"
                                                render="spmpanel"
                                                rendered="#{labelDeliveryRequestSender.editSpecimen}">
                                            <span class="gzl-icon-random"/>
                                        </a4j:commandLink></f:facet>
                                    <f:subview id="editspm"
                                               rendered="#{labelDeliveryRequestSender.editSpecimen}">
                                        <ui:include src="/lab/fillingSpecimen.xhtml">
                                            <ui:param name="specimen"
                                                      value="#{labelDeliveryRequestSender.selectedSpecimen}"/>
                                            <ui:param name="managedBean" value="#{labelDeliveryRequestSender}"/>
                                            <ui:param name="askForNumberOfContainers" value="false"/>
                                        </ui:include>
                                    </f:subview>
                                    <f:subview id="viewspm"
                                               rendered="#{not labelDeliveryRequestSender.editSpecimen}">
                                        <ui:include src="/lab/specimenDetails.xhtml">
                                            <ui:param name="specimen"
                                                      value="#{labelDeliveryRequestSender.selectedSpecimen}"/>
                                        </ui:include>
                                        <div class="row col-lg-6">
                                            <ui:decorate template="/layout/display/_display_field_horizontal_3-9.xhtml">
                                                <ui:param name="id" value="sacnb"/>
                                                <ui:define name="label">#{messages['gazelle.ordermanager.NumberOfNeededLabels']}</ui:define>
                                                <h:outputText value="#{labelDeliveryRequestSender.labelCount}"/>
                                                <span style="width:10px"/>
                                                <a4j:commandLink
                                                        actionListener="#{labelDeliveryRequestSender.addALabel()}"
                                                        oncomplete="jq162('#newContainerPanel').modal('show')"
                                                        title="#{messages['gazelle.ordermanager.CreateAnAdditionalLabel']}"
                                                        render="newContainerPanel, sacContent">
                                                    <span class="gzl-icon-plus"/>
                                                </a4j:commandLink>
                                            </ui:decorate>
                                        </div>
                                    </f:subview>
                                    <f:facet name="footer">
                                        <a4j:commandButton value="#{messages['gazelle.ordermanager.AddAnOrder']}" styleClass="gzl-btn-green"
                                                           actionListener="#{labelDeliveryRequestSender.createNewOrderForSpecimen()}"
                                                           render="newObjectPart"/>
                                        <a4j:commandButton value="#{messages['gazelle.ordermanager.SendRequest']}" styleClass="gzl-btn-blue"
                                                           actionListener="#{labelDeliveryRequestSender.sendMessage()}"
                                                           render="globalDiv"
                                                           rendered="#{not labelDeliveryRequestSender.editSpecimen}"/>
                                    </f:facet>
                                </gri:panel>
                                <gri:panel rendered="#{labelDeliveryRequestSender.labelCount gt 1}" pid="saclist">
                                    <f:facet name="header">#{messages['gazelle.ordermanager.AdditionalLabels']}</f:facet>
                                    <rich:dataTable
                                            value="#{labelDeliveryRequestSender.selectedSpecimen.containers}"
                                            var="sac" id="labelTab" render="ds"
                                            rows="#{dataScrollerMemory.numberOfResultsPerPage}">
                                        <g:column>
                                            <ui:define name="header">#{messages['gazelle.ordermanager.ContainerId']}</ui:define>
                                            <h:outputText value="#{sac.containerIdentifier}"/>
                                            <ui:decorate template="/layout/popover/_popover_on_icon.xhtml">
                                                <ui:param name="id" value="det#{sac.id}"/>
                                                <ui:param name="icon_class" value="gzl-icon-question-circle"/>
                                                <ui:param name="placement" value="#{messages['gazelle.ordermanager.Right']}"/>
                                                <ui:define name="content">
                                                    <ui:include src="/lab/containerDetails.xhtml">
                                                        <ui:param name="container" value="#{sac}"/>
                                                        <ui:param name="displayOrders" value="false"/>
                                                    </ui:include>
                                                </ui:define>
                                            </ui:decorate>
                                        </g:column>
                                        <g:column>
                                            <ui:define name="header">#{messages['gazelle.ordermanager.ParentContainerId']}</ui:define>
                                            #{sac.primaryContainerIdentifier}
                                        </g:column>
                                        <g:column>
                                            <ui:define name="header">#{messages['gazelle.ordermanager.CapType']}</ui:define>
                                            #{sac.capType}
                                        </g:column>
                                        <g:column>
                                            <ui:define name="header">#{messages['users.Action']}</ui:define>
                                            <a4j:commandLink
                                                    actionListener="#{labelDeliveryRequestSender.removeLabel(sac)}"
                                                    render="saclist" title="#{messages['gazelle.ordermanager.RemoveLabel']}">
                                                <span class="gzl-icon-trash-o"/>
                                            </a4j:commandLink>
                                        </g:column>
                                        <f:facet name="footer">
                                            <ui:include src="/util/datatableFooter.xhtml">
                                                <ui:param name="dataScrollerId" value="ds"/>
                                                <ui:param name="dataTableId" value="labelTab"/>
                                            </ui:include>
                                        </f:facet>
                                    </rich:dataTable>
                                </gri:panel>
                                <gri:panel rendered="#{not empty labelDeliveryRequestSender.selectedSpecimen.orders}"
                                           pid="orclist">
                                    <f:facet name="header">#{messages['gazelle.ordermanager.RelatedOrders']}</f:facet>
                                    <rich:dataTable value="#{labelDeliveryRequestSender.selectedSpecimen.orders}"
                                                    var="orc"
                                                    id="orctab">
                                        <ui:include src="/common/orderColumns.xhtml">
                                            <ui:param name="managedBean" value="#{labelDeliveryRequestSender}"/>
                                            <ui:param name="currentOrder" value="#{orc}"/>
                                            <ui:param name="displayEncounterInfo" value="false"/>
                                        </ui:include>
                                        <g:column>
                                            <ui:define name="header">#{messages['users.Action']}</ui:define>
                                            <a4j:commandLink
                                                    title="#{messages['gazelle.ordermanager.RemoveThisOrderFromTheSpecimen']}"
                                                    actionListener="#{labelDeliveryRequestSender.removeOrderFromSpecimen(orc)}"
                                                    render="orclist">
                                                <s:span styleClass="gzl-icon-trash-o"/>
                                            </a4j:commandLink>
                                        </g:column>
                                        <f:facet name="footer">
                                            <ui:include src="/util/datatableFooter.xhtml">
                                                <ui:param name="dataScrollerId" value="ds"/>
                                                <ui:param name="dataTableId" value="orctab"/>
                                            </ui:include>
                                        </f:facet>
                                    </rich:dataTable>
                                </gri:panel>
                            </s:div>
                            <gri:panel rendered="#{labelDeliveryRequestSender.currentOrder != null}" pid="orcdetails">
                                <f:facet name="header">
                                    <h:outputText value="#{messages['gazelle.ordermanager.CreateOrder']}"/>
                                    <span style="width:10px"/>
                                    <a4j:commandLink title="#{messages['gazelle.ordermanager.FillWithRandomValues']}"
                                                     actionListener="#{labelDeliveryRequestSender.fillOrderRandomly()}"
                                                     immediate="true"
                                                     render="orcdetails">
                                        <span class="gzl-icon-random"/>
                                    </a4j:commandLink>
                                </f:facet>
                                <ui:include src="/lab/fillingLabOrder.xhtml">
                                    <ui:param name="order" value="#{labelDeliveryRequestSender.currentOrder}"/>
                                    <ui:param name="displayExtraParamForOF" value="false"/>
                                    <ui:param name="isWorkOrder" value="false"/>
                                    <ui:param name="valueResultStatus" value="false"/>
                                </ui:include>
                                <f:facet name="footer">
                                    <a4j:commandButton value="#{messages['gazelle.HL7Common.Back']}"
                                                       actionListener="#{labelDeliveryRequestSender.setCurrentOrder(null)}"
                                                       styleClass="gzl-btn-orange" immediate="true"
                                                       render="newObjectPart"/>
                                    <a4j:commandButton value="#{messages['gazelle.ordermanager.AddToSpecimen']}"
                                                       actionListener="#{labelDeliveryRequestSender.addOrderToSpecimen()}"
                                                       styleClass="gzl-btn-green" render="newObjectPart"/>
                                </f:facet>
                            </gri:panel>
                        </s:div>
                        <!-- Exchange messages -->
                    </s:div>
                    <s:div id="hl7MessagesDiv">
                        <gri:panel rendered="#{labelDeliveryRequestSender.hl7Messages != null}">
                            <f:facet name="header">#{messages['gazelle.ordermanager.TestReport']}</f:facet>
                            <ui:include src="/messages/message_table.xhtml">
                                <ui:param name="hl7Messages" value="#{labelDeliveryRequestSender.hl7Messages}"/>
                            </ui:include>
                            <f:facet name="footer">
                                <a4j:commandButton value="#{messages['gazelle.ordermanager.PerformAnotherTest']}"
                                                   styleClass="gzl-btn-blue"
                                                   actionListener="#{labelDeliveryRequestSender.setHl7Messages(null)}"
                                                   render="globalDiv"/>
                            </f:facet>
                        </gri:panel>
                    </s:div>
                </gri:panel>

            </s:div>
            <ui:include src="/hl7Initiators/addContainerToLabel.xhtml"/>
        </h:form>
    </ui:define>
</ui:composition>
